;*******************************************************************************
;				FM_SSD1306_enc.asm
;	 FM-   RDA5807M  OLED- SSD1306
;  ATMEGA8    .  8 .
; 		  :
;-*-        User_set.asm.
;-*-          
;	     .
;-*-          
;-*-       .
;-*-         
;-*-      .
;-*-         
;-*-      .
;-*-        .
;-*-       .
;-*-       EEPROM.
;-*-       .
;-*-       .
;-*-  "-" .
;-*-    16 .      .
;-*-   .
;
;  :
; PD7 - .   -
;
; PC0 -    
; PC1 -    
; PC2 -  
; PC3 - 
; PC4 - (SDA) -    I2C
; PC5 - (SCL) -    I2C
;
;*******************************************************************************
	;     /
    .NOLIST                 ; 
	.include "m8def.inc"	;   - ATMega8
    .LIST                   ; 
    .device ATmega8         ; 
    #define F_CPU (8000000) ; 
  	;   
  	.def fnt_d = R6			; 
  	.def cntrl	= R13    	;  
  		.equ ENC = 0			;  
  		.equ SEK = 1			;  
  		.equ AUS = 2			;  
	.def temp  = r16 		;
	.def temp1 = r17 		; 
	.def temp2 = r18 		; 
	.def temp3 = r19 		;  
	.def flags = r20 		; 
	.def time  = r21		;  
	.def F_3H  = r22		;.   
	.def F_3L  = r23		;.   
	.def freq  = r24		;   ( )
	
	.equ Tm_l  = 2			;   2*8=16 .
	
;===============================  ============================================
	.MACRO DELAY					; 1   32 
		ldi time,@0					;    0
	 	tst time					;,  0  R21  0
		brne PC-1					;
	.ENDMACRO
		
	.MACRO LOAD_ADDR 		 		;   16- 
		ldi @0l,low(@1)   			;: LOAD_ADDR Z,12365
		ldi @0h,high(@1)  			;
	.ENDMACRO
		
	.MACRO 	POZ_LCD					;    LCD:
		ldi temp,@0					;    ,
		rcall lcd_Y					;
		ldi temp,@1					;   
		rcall lcd_X					;
	.ENDMACRO						;: POZ_LCD 12,5
;===============================================================================
	.DSEG					;   SRAM ()
	.ORG 0x060				;   
	decnum:		.BYTE 5		;A    
	seek_fm:	.byte 1		;  
	read_fm:	.byte 1 	; ()  
	level:		.byte 1		; 
	volume:		.byte 1		;
	
	str_num: .byte 1		;   Y
	poz_num: .byte 1  		;    X
;=============================================================================
	.ESEG						;    EEPROM
	 Fst_EE:	.BYTE 1 		;   ( )
	 Vol_EE:	.BYTE 1 		; 
;=============================================================================
	.CSEG		;  
	.ORG 0 		; 
	rjmp RESET			;Reset
	reti				;  INT 0
	reti				;  INT 1
	reti				; / 2  
	rjmp OVF_T2			; / 2  
	reti  				; / 1   
	reti				; / 1     
	reti				; / 1     
	rjmp OVF_T1			; / 1  
	rjmp OVF_T0			; / 0  
	reti				;  SPI 
	reti				; UART   
	reti				; UART   
	reti				; UART  
	reti 				;   
	reti				; EEPROM 
	reti				;   
	reti    			;  - 2- 
	reti				; SPM
	
;============================================================================
RESET:		;   ,  
		;  
		LDI 	Temp, LOW(RAMEND)
		OUT 	SPL, Temp
		LDI 	Temp, HIGH(RAMEND)
		OUT 	SPH, Temp
		CLI							;   
;-----------------------------------------------------------------------------
		;  B
	;	ldi temp,0b11111111			;
	;	out DDRB,temp   			;      
	;	ldi temp,0b00000000			;
	;	out PORTB,temp   			;   D  
			;  ,  .    
	 	ldi temp,0b00000000			;      
		out DDRC,temp   			;
		ldi temp,0b11111111			;
		out PORTC,temp   			;  
		
			;  D
	 	ldi temp,0b10000000			;   D
		out DDRD,temp				;
		ldi temp,0b01111111			;
		out PORTD,temp				;
		
			; 
		;  :
		; (1/8000000)*1024)*256=0,032768  = 32,768   . 1/1024
		clr temp					; .  0 1  2
		ldi temp,(1<<TOIE2)|(1<<TOIE1)|(1<<TOIE0)	; 
		out TIMSK,temp				;
		ldi temp,0b00000101			; 
		out TCCR0,temp				;  0   1/1024
		out TCCR1B,temp				;  1   1/1024
		
		sei                         ;  
		
;===================   ==================================
		; 
		rcall IIC_init				;  I2C
		rcall lcd_init				; LCD 
		clr fnt_d					;   
		inc fnt_d					;  
		;    
		POZ_LCD 0,0					;0- , 0- 
		LOAD_ADDR Z,Messg1*2		;.  Z  
		rcall Str_LCD				; .
;------------------------------------------------------------------------------
		;  RDA5807
		ldi YL,LOW(Fst_EE)			;.  Y ..  
		clr YH						;
		ldi temp,15					; 
		sts volume,temp				;   = 15
		rcall Rd_St					;   EEPROM
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		DELAY 20					; 656 
		;      
		rcall Prnt_F				;   
		rcall rekog					;/  
		;    
		rcall ch_st					; RDA5807
		DELAY 20					; 656 
		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		ldi R17,0xAF				; 
		rcall lcd_com				;   LCD
		ldi temp,0b00000101			;  1
		out TCCR1B,temp				;   1/1024
		; 
		clr R2						;  
		clr R8						;   
		clr R10						;  .  
		clr cntrl					;  .
		clr freq					;  
		clr temp3					;  R19
		ldi temp,Seek_Mode			;  
		mov R8,temp					;   
		
;-------------------- ----------------------------------------------
main: 
		sbrc cntrl,ENC				;  , -
		rjmp mn_upr					;    ,
		sbrc cntrl,SEK				;   , -
		rcall ch_seek				;   
		sbrc cntrl,AUS				;   , -
		rcall av_seek				;    
		clr cntrl					;   
			; 
mn_upr:	in temp,PINC				;  
		andi temp,0b00000111		; 
		cpi temp,7					;   , -
		breq main					;   
		;
		sbrs temp,2					;   , -
		rjmp mn_au					;   
		;   
		mov  temp2,temp				;
		andi temp2,0b00000011		;  
		cpi temp2, 1				;   1, 
		breq mn_1					;   R10=1
		cpi temp2, 2				;   2, 
		breq mn_2					;   R10=2
		tst temp2					;   
		breq mn_3					;  
		rjmp main					;
		
mn_1:	ldi temp2,1					;
		mov R10,temp2				; R10=1
		rjmp main					;
		
mn_2:	ldi temp2,2					;
		mov R10,temp2				; R10=2
		rjmp main					;
		
mn_au:	clr temp					;   , -
		sbr temp,4					; 
		mov r1,temp					;  R1=4
		rjmp mn_4					;
		
mn_3:	mov r1,R10					;   
		
		;   ()
mn_4:	DELAY 1						; 32  
		cp r1,r2					;  
		brne main					;  -  
		tst R2						;   ,-
		breq main					;  
		;  
		ldi temp,Tm_l				; 
		mov R12,temp				;  
		ldi R17,0xAF				; 
		rcall lcd_com				;   LCD
		ldi temp,0b00000101			;  1
		out TCCR1B,temp				;   1/1024
		
		;  , .  
		mov temp,R1					;
		cpi temp,0x4				;   , -
		brne PC+3					;
		rcall mode_s				;   
		rjmp m_loop					; 
		;  
		tst R8						;   
		brne avto					;    
		;  
		sbrc R10,0					;  , -
		rcall Num_Up				;     
		sbrc R10,1					;  , -
		rcall Num_Down				;     
		rjmp m_loop					; , -  
avto:	;
		sbrc R10,0					;  , -
		rcall Frq_pl				; 
		sbrc R10,1					;  , -
		rcall Frq_mi				; 
		
m_loop: clr R10						;
		clr R2						;
		rjmp main					;   
		
		;
;===========================================================================
 Num_Up:			;   
 		clr R1						;
 		inc R9						;  
		mov temp,R9					;
 		cpi temp,Nst				;    > Nst
 		brmi PC+2					;
 		clr  R9						;    0
		rcall type_ch				;    LCD 
		DELAY 7						;
		
		ldi temp,255				;  
		mov R14,temp				;
		ldi temp,0b00000100			;  2   1/64
		out TCCR2,temp				;
		clr temp					;
		sbr temp,(1<<ENC)+(0<<SEK)	;   
		mov cntrl,temp				;
		
 		clr temp					;
 		
 		ret
 		
 ;===========================================================================
 Num_Down:			;   
 		clr R1						;  
		dec R9						;   ,
 		tst R9						;   > 0,  
 		brpl um_nom					;   ,  -
 		ldi temp,Nst-1				;
 		mov R9,temp					;
 um_nom:
 		rcall type_ch				;    LCD 
 		DELAY 7						;
 		
 		ldi temp,255				;   
		mov R14,temp				;
		ldi temp,0b00000100			;  2   1/64
		out TCCR2,temp				;
		clr temp					;
		sbr temp,(1<<ENC)+(0<<SEK)	;   
		mov cntrl,temp				;
 		
		clr temp					;
 		
 		ret
 		
;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_ch:	;    LCD
		POZ_LCD 7,0					;7- ,0- 
		LOAD_ADDR Z,Messg3*2		;.  Z   
		rcall Str_LCD				;   
		POZ_LCD 7,0					;7- ,0- 
		
			;    10- 
		clr temp1					;
		mov temp,R9					;  
		inc temp					;   1
		rcall bin16_dec5			;  10- 
		ldi YL,LOW(decnum)			;.  X . .   
		clr YH						;
		inc YL						; .    
			;    LCD 
		ld temp,Y					; .   
		tst temp					;    0,  -
		brne PC+2					;    
		rjmp PC+3					;
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;   LCD
		ld temp,-Y					; .   
		subi temp, -0x30			;   ASCII-
		rcall lcd_put_char			;   LCD
		
		ret
		
;===========================================================================
mode_s:		;   /
		tst R8						;   
		brne rev					;
		mov R8,R2					;  
		rjmp rev_end				;
rev:	clr R8						;   
rev_end:			;  
		POZ_LCD 7,0					;7- ,0- 
		LOAD_ADDR Z,Messg3*2		;.  Z  
		rcall Str_LCD				; .  LCD
		;  
		sbis PINC,PC2				;    
		rjmp PC-1					;   
		clr temp					; temp    
 		ret
 		
;===========================================================================
Frq_pl:		;  
		tst R7						;   , 
		brne Frq_inc				;   
		;  ""
		POZ_LCD 7,0					;7- ,0- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
		cbi PORTD,7					;  
		rcall Rd_St					;   EEPROM
Frq_inc:		
		inc freq					; 
		cpi freq,210				;    >210
		brlo PC+2					; 210+870=1080
		clr freq					;  freq =0
		rcall Auto_F				;   
		ldi temp,1					;   
		mov R7,temp					;   
		DELAY 5						;
		
		ldi temp,255				;  
		mov R14,temp				;
		ldi temp,0b00000100			;  2   1/64
		out TCCR2,temp				;
		clr temp					;
		sbr temp,(1<<ENC)+(0<<AUS)	;   
		mov cntrl,temp				;
		
		ret
		
;===========================================================================
Frq_mi:		;  
		tst R7						;   , 
		brne Frq_dec				;   
		;  ""
		POZ_LCD 7,0					;7- ,0- 
		LOAD_ADDR Z,Messg5*2		;.  Z  
		rcall Str_LCD				; .  LCD
		rcall Mono					; ""
		cbi PORTD,7					;  
		rcall Rd_St					;   EEPROM
Frq_dec:		
		dec freq					; 
		brne PC+2					;
		ldi freq,210				;
		rcall Auto_F				;   
		ldi temp,2					;   
		mov R7,temp					;   
		DELAY 5						;
		
		ldi temp,255				;  
		mov R14,temp				;
		ldi temp,0b00000100			;  2   1/64
		out TCCR2,temp				;
		clr temp					;
		sbr temp,(1<<ENC)+(0<<AUS)	;   
		mov cntrl,temp				;
		
		ret
		
;===========================================================================
av_seek: 	;  
		sbrc R7,0					; R7=1
		rcall freq_Up				;    
		sbrc R7,1					; R7=2
		rcall freq_Down				;    
		clr R7						; R7
		
		ret
		
;===============================================================
freq_Up: 	;   "+"   
		cli							; 
	;		rjmp st_tn		// 
			;     
		ldi temp,0b10010011			;(02H) ., DMUTE=0,,,
									; SEEKUP=1, SEEK=1 ( )
		mov r5,temp					; - 
r_con:	rcall Config_RDA5807		; 
		
nov_p:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_p					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		cpi freq,210				;    >210,
		brlo PC+2					; .. 210+870=1080,
		clr freq					;  freq =0
		rjmp r_con					;  
		
		rjmp st_tn					;  
		clr temp					; temp    
		sei							; 
 		ret
;===========================================================================
freq_Down:	;   "-"   
		cli							; 
	;		rjmp st_tn		// 
			;     
		ldi temp,0b10010001			;(02H) ., DMUTE=0,,,
									; SEEKUP=0, SEEK=1 ( )
		mov r5,temp					; - 
rm_con:	rcall Config_RDA5807		; 
		
nov_m:	DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds r17,seek_fm				;  . 
		sbrs r17,6					;STC=1?    , -
		rjmp nov_m					;  . 
		
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		lds freq,read_fm			;  
		lds r17,seek_fm				;  . 
		sbrs r17,5					;SF=1?   , -
		rjmp st_tn					;  
		tst freq					;    =0
		brne PC+2					; 210+870=1080
		ldi freq,210				;  freq =210
		rjmp rm_con					;  
		
		;     
st_tn:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									; SEEKUP=1, SEEK=0 ( )
		mov r5,temp					; - 
		rcall Config_RDA5807		; 
		
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall Ster					; ""
		rcall type_lev				;  
		rcall Prnt_F				;   
		rcall rekog					; 
		
		clr temp					; temp    
		sei							; 
 		ret
;===========================================================================
;	/     
;---------------------------------------------------------------------------

 ch_seek:		;     . 
 		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
 		tst R9						;
 		breq st_set					;  =0,   
 		push R9						;
		adiw Z,12					;    . 
		dec R9						;
		brne PC-2					;
		pop R9						;
		
st_set:	lpm freq,Z					;   FLASH
		adiw Z,1					;    
		rcall Prnt_F				;   
		rcall rekog					; 
		;   
ch_st:	ldi temp,0b11010010			;(02H) ., DMUTE=1,,,
									;SEEKUP=1, SEEK=0 ( )
		mov r5,temp					;
		rcall Config_RDA5807		;  /
		
		cbi PORTD,7					;  
		rcall Mono					; ""
		DELAY 20					;
		rcall Read_RDA5807			;   RDA5807
		DELAY 5						;
		
		lds r17,seek_fm				;  . 
		sbrc r17,2					; , -
		sbi PORTD,7					;   
		rcall Ster					; ""
		rcall type_lev				;  
		clr temp					; temp    
		
		sei
		ret
		
;===========================================================================
;		/  
;---------------------------------------------------------------------------
rekog:	cli							; 
		clr R9						;
		LOAD_ADDR Z,freq_st*2		;.  Z . ..  
rd_fr:	lpm temp,Z					;   FLASH
		cp temp,freq				;  ,   ,  -
		breq na_ind					;    
		inc R9						;  
		mov temp,R9					;  ,
		cpi temp,Nst				;    , -
		brsh fall					;     
		adiw Z,12					;   
		rjmp rd_fr					;  
		
fall:	LOAD_ADDR Z,Messg3*2		;.  . "             "
		rjmp Prn_Ch					;   
		
na_ind:	adiw Z,1					;    
			;    
Prn_Ch:	POZ_LCD 7,0					;7- ,0- 
		rcall Str_LCD				;    
		sei							; 
		
		ret
		
;===========================================================================
;			 /   RDA5807M
;---------------------------------------------------------------------------
Read_RDA5807:
		cli						; 
		rcall IIC_Start			;  
		ldi temp,0b00100001		;   021
		rcall IIC_Send			;  
		
		rcall IIC_Recieve		;(0)   
		sts seek_fm,temp		;    . 
		
		rcall IIC_Recieve		;(0L)   
		sts read_fm,temp		;     
		mov freq,temp			;     
		
		rcall IIC_Recieve_lst	;(0B)   
		lsr temp				;   
		sts level,temp			;      
		
		rcall IIC_Stop			;  
		sei						; 
		
		ret
		
;===========================================================================
;	 /    , ( YH:YL   )
;---------------------------------------------------------------------------
Rd_St:	
		cli							; 
		LOAD_ADDR Y,Fst_EE			;.  Y . .. 
		clr freq					;
Rd_EEF:	sbic EECR,EEWE				;   
		rjmp Rd_EEF					;
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		sbi EECR,EERE				;  
		in freq,EEDR				;   . 
		
		sei							; 
		ret
;===========================================================================
; 			    RDA5807
;---------------------------------------------------------------------------
Config_RDA5807: 
		cli							; 
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;     
; .F_3H . 8  .  .F_3L .2  . &  ..
		mov F_3H,freq				;
		clc							;  
		clr F_3L					;
		lsr F_3H					;
		ror F_3L					;
		lsr F_3H					;
		ror F_3L					;
		ori F_3L,0x10				;   
		;     RDA5807
		rcall iic_start				; 
		ldi temp,0x20				;    RDA5807
		rcall IIC_Send				;  
		
		mov temp,r5					;   -
		rcall IIC_Send				;(02) = r5
		ldi temp,0b10000101			;(02L):  SKMODE=1 Fclk=32.768kHz,
		rcall IIC_Send				; RDS_EN=0,NEW_METHOD=1, Power Up
		
		mov temp,F_3H				;(03H) . 8  
		rcall IIC_Send				;
		mov temp,F_3L				;(03L) .2  . &  ..
		rcall IIC_Send				;	87108 MHz	 100 
		
		ldi temp,0					;(04H)
		rcall IIC_Send				;
		ldi temp,0					;(04L)
		rcall IIC_Send				;
		
		ldi temp,0b10001000 		;(05H)- .,  . 
		rcall IIC_Send				;
		lds temp,volume				;(05L)     
		ori temp,0b10000000			;
		rcall IIC_Send				;  
		
		rcall iic_stop 				; 
		rcall Wr_EEF				;    
		
		pop R16          		;   SREG
    	out SREG,R16     		;
    	pop R16          		;   R16
		sei							; 
		ret
;===========================================================================
;		    ,  YH:YL   
;---------------------------------------------------------------------------
Wr_EEF:	
		cli							; 
		ldi YL,LOW(Fst_EE)			;.  Y . ..
		clr YH						; .   
		sbic EECR,EEWE				;  
		rjmp PC-1					;   EEWE
		out EEARH,YH				; .   
		out EEARL,YL				; .   
		out EEDR,freq				;  
		sbi EECR,EEMWE				;   
		sbi EECR,EEWE				;  
		sei							; 
		
		ret

;===========================================================================
;		/     LCD 
;---------------------------------------------------------------------------
type_lev:
		;    LCD
		POZ_LCD 0,2					;0- ,2- 
		
		lds temp,level				;     
		
		cpi temp,51					; 4- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg10*2		;.  Z . . " 4"
		rjmp tp_lev					;    /
		
		cpi temp,38					; 3- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg9*2		;.  Z . . " 3"
		rjmp tp_lev					;    /
		
		cpi temp,25					; 2- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg8*2		;.  Z . . " 2"
		rjmp tp_lev					;    /
		
		cpi temp,12					; 1- 
		brmi PC+4					;
		LOAD_ADDR Z,Messg7*2		;.  Z . . " 1"
		rjmp tp_lev					;    /
		
		LOAD_ADDR Z,Messg6*2		;.  Z . . " 0"
		
tp_lev:	rcall Str_LCD				;   
		
		ret

;===========================================================================
; /     0
;---------------------------------------------------------------------------
OVF_T0:	
		push R16          	;   R16
    	in R16,SREG      	;
   		push R16         	;   SREG
		;
		dec time			; 
		
		tst R1				;     
		breq T0_ex			;   /,  -
		mov R2,R1			;    
		
T0_ex:	pop R16          	;   SREG
    	out SREG,R16     	;
    	pop R16          	;   R16
		
		reti
		
;===========================================================================
; /     1
;---------------------------------------------------------------------------
OVF_T1:	
		push R17          	;   R19
    	in R17,SREG      	;
   		push R17         	;   SREG
		;
		dec R12				; 
		tst r12				;    , -
		brne T1_ex			;   /,  -
		
		ldi R17,0xAE		;(0xAE)	  ( )
		rcall lcd_com		;   LCD
		
		ldi R17,0			;  2
		out TCCR1B,R17		;
		;
T1_ex:	pop R17          	;   SREG
    	out SREG,R17     	;
    	pop R17          	;   R19
		
		reti
		
;===========================================================================
; /     2
;---------------------------------------------------------------------------
OVF_T2:	
		push R19          	;   R19
    	in R19,SREG      	;
   		push R19         	;   SREG
		;
		dec R14				;    , -
		brne T2_ex			;   /,  -
		
		sbrs cntrl,ENC		;  , -
		rjmp podsv			;    ,
		
		;  
		tst R8						;   
		brne s_auto					;    
		
		clr R19						;
		sbr R19,(0<<ENC)+(1<<SEK)	;    
		mov cntrl,R19				;  . 
		rjmp podsv					; 
		
s_auto:	clr R19						;
		sbr R19,(0<<ENC)+(1<<AUS)	;    
		mov cntrl,R19				;  . 
		
podsv:	ldi R19,0			;  2
		out TCCR2,R19		;
		
		;
T2_ex:	pop R19          	;   SREG
    	out SREG,R19     	;
    	pop R19          	;   R19
		
		reti
		
;===========================================================================
;		    LCD 
;---------------------------------------------------------------------------
 Prnt_F:
		;    
		clr r18					;
		ldi r17,HIGH(870)		;  
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		LOAD_ADDR Y,decnum+3	;.  Y . .   
			;  
		;    LCD
		POZ_LCD 2,2				;2- ,2- 
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne Fr_100				;    
		ldi temp,0x0A			;  
		rcall D_trep			;  LCD 
		rjmp Fr_10				;
		;  LCD  
Fr_100:	rcall D_trep			;  
		;  LCD  
Fr_10:	ld temp,-Y				; .  
		rcall D_trep			;  
		;  LCD  
		ld temp,-Y				; .  
		rcall D_trep			;  
		
		;  LCD 
		ldI temp,0x0B			; 
		rcall D_trep			;   LCD 
		;   
		ld temp,-Y				; .  
		rcall D_trep			;   
		;  ""
		POZ_LCD 4,14			;4- ,14- 
		LOAD_ADDR Z,Messg4*2	;.  Z . . ""
		rcall Str_LCD			;   
		
		ret
		
;===========================================================================
;		     
;---------------------------------------------------------------------------
 Auto_F:		;      
		;    LCD
		POZ_LCD 7,0				;7- , 0- 
		;    
		clr r18					;
		ldi r17,HIGH(870)		;  
		ldi temp,LOW(870)		; : 870  
		add temp,freq			;   
		adc r17,r18				;
		;   10- 
		rcall bin16_dec5		;  10- 
		LOAD_ADDR Y,decnum+3	;.  Y . .   
		;  
		ld temp,Y				; .  
		tst temp				;    0,  -
		brne PC+4				;    
		ldi temp,0x20			;  
		rcall lcd_put_char		;  LCD 
		rjmp PC+3				
		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;  
		
		ld temp,-Y				; .  
		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;  LCD 
		
		ld temp,-Y				; .  
		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;  LCD 
		;  LCD 
		ldI temp,0x2C			; 
		rcall lcd_put_char		;  LCD 
		
		;  LCD   
		ld temp,-Y				; .  
		subi temp, -0x30		;   ASCII-
		rcall lcd_put_char		;  LCD 
		
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Mono:	push R30					;
		push R31					;
		; . "  "   
		POZ_LCD 0,18				;0- ,9- 
		ldi temp,'M'				;
		rcall lcd_put_char			;  ""  LCD
		
		cbi PORTD,7					; 
		pop R31						;
		pop R30						;
		ret
		
;===========================================================================
;    ""
;---------------------------------------------------------------------------
Ster:	push R30					;
		push R31					;
		; . ""   
		POZ_LCD 0,18				;0- ,9- 
		ldi temp,'S'				;
		rcall lcd_put_char			;  ""  LCD
		
		sbi PORTD,7					; 
		pop R31						;
		pop R30						;
		ret

;===========================================================================
;  2-    5-
;  (  d4d0   SRAM )
;
; R17:R16    ,    (00xFFFF)
; R18,R19,R20   
; [YH:YL]        YH:YL
; decnum      
;---------------------------------------------------------------------------
 bin16_dec5:
 	cli
 	push R18
 	push R19
 	push R20
     ldi   YL,low(decnum) 	;   Y 
     ldi   YH,high(decnum) 	;    d0d4  
     ldi   R20,4    		;   
bd1: clr   R18      		;   R18
     ldi   R19,16   		;    
bd2: lsl   R16      		;   V(D)/10
     rol   R17      		;     R17:R16,
     rol   R18      		;    R18 = di
     andi  R16,0xFE
     cpi   R18,10
     brcs  bd3
     subi  R18,10
     ori   R16,0x01
bd3: dec   R19
     brne  bd2
     st    Y+,R18   		;  di  
     dec   R20
     brne  bd1      		;  n-1 
     st    Y+,R16   		;   dn-1  
    pop R20
    pop R19
    pop R18
     sei
     ret
	
;====================================================================================
;******************************************************************************
	.include "I2C_hard_driver.asm"		;   I2C
	.include "Driver_SSD1306.asm"		; LCD SSD1306
	.include "User_set.asm"				; 
;******************************************************************************
;===========================================================================
		;     
  Messg1: .DB  130,131,131,' ',' ',' ',' ',' ',' ',' ', 0, 0		;. .
  Messg2: .DB  '','','','','','.',' ','','','', 0, 0
  Messg3: .DB  ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ', 0, 0		; .
  Messg4: .DB  '','','',0
  Messg5: .DB  ' ',' ',' ',' ',' ',' ','A','U','T','O', 0, 0
  
  Messg6: .DB  131,131, 0, 0	; 0
  Messg7: .DB  132,131, 0, 0	; 1
  Messg8: .DB  133,131, 0, 0	; 2
  Messg9: .DB  133,134, 0, 0	; 3
  Messg10: .DB 133,135, 0, 0	; 4
  
  Messg11: .DB  ' ','','','','',' ', 0, 0
  Messg12: .DB  '','','','','','', 0, 0
  

;=================================================================================

	.EXIT
	